{$APPTYPE CONSOLE}

uses
  Windows, Resizer, Types, PngImageLite, Graphics;

var
  P: TPNGObject;
  hdcScreen, hdcCompatible: hDC;
  B, BR: hBitmap;
  TB: TBitmap;
  C: cardinal;

begin
  repeat
    Write('Initializing...');C:=GetTickCount;
    hdcScreen := GetDC(0);
    hdcCompatible := CreateCompatibleDC(hdcScreen); 
    ReleaseDC(0, hdcScreen);
    WriteLn(GetTickCount-C);

    if hdcCompatible=0 then 
      begin WriteLn('CreateCompatibleDC fail');Exit;end;

    P:=TPNGObject.Create;
    P.LoadFromFile('C:\1.png');

    B:=CreateBitmap(P.Width, P.Height, 4, 8, nil);
    if B=0 then 
      begin WriteLn('CreateBitmap fail');Exit;end;
    if SelectObject(hdcCompatible, B)=0 then
      begin WriteLn('SelectObject fail');Exit; end;
    
    Write('Drawing...');C:=GetTickCount;
    P.Draw(hdcCompatible, Rect(0, 0, P.Width, P.Height));
    P.Free;
    WriteLn(GetTickCount-C);
    
    DeleteDC(hdcCompatible);

    Write('Resizing...');C:=GetTickCount;
    BR:=_ScaleBitmapInt(B, 320, 240);
    DeleteObject(B);
    WriteLn(GetTickCount-C);

    Write('Saving...');C:=GetTickCount;
    TB:=TBitmap.Create;
    TB.Handle:=BR;
    TB.SaveToFile('1.bmp');
    TB.Free;    // DeleteObject(BR) not needed
    WriteLn(GetTickCount-C);
  until False;
end.