{$APPTYPE CONSOLE}

uses
  Windows, LeadTools, pngimagelite, Graphics;

var
  //F: hFile;
  F: TFileStream;
  DIB: THandle;
  B: hBitmap;
  TB: TBitmap;
  //DIBinMemory: Pointer;
  L: L_Image;
  Buffer: array[0..696-1, 0..(1920 div 8)-1] of Byte;
  ofstruct: TOFStruct;
  DIBinMemory, P: Pointer;
  I: Integer;

begin
  if not LeadToolsLoaded then
    begin WriteLn('Load failure');Exit end;
  repeat
    //F := OpenFile('2worm assault.BIT', ofstruct, 0);
    //F := CreateFile('2worm assault.BIT', STANDARD_RIGHTS_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, 0, 0);
    //if F=INVALID_HANDLE_VALUE then
    //  begin WriteLn('CreateFile failed');Exit end else WriteLn('CreateFile OK');
    F:=TFileStream.Create('2worm assault.BIT', [fsmRead]);
    
    FillChar(L, SizeOf(L), 0);
    if L_LoadFileOffset(F.Handle, 40, F.Size-40, L, 1, 0, 3, 0, 0)<=0 then
      begin WriteLn('L_LoadFileOffset failed');Exit end else WriteLn('L_LoadFileOffset OK');
    //CloseHandle(F);
    F.Free;
    
    if(L.Width<>1920)or(L.Height<>696) then
      begin WriteLn('Bad size');Exit end;

    DIB := L_ConvertToDIB(L);
    if DIB=0 then
      begin WriteLn('L_ConvertToDIB failed');Exit end;
    L_FreeBitmap(L);

    DIBinMemory := GlobalLock(DIB);

    B := CreateBitmap(L.Width, L.Height, 1, 1, nil);     // Pointer(Integer(DIBinMemory)+40 + 2*SizeOf(TRGBQuad))
    if B=0 then
      begin WriteLn('CreateBitmap failure');Exit end;

    for I:=0 to 696-1 do
      begin
      P := Pointer(Integer(DIBinMemory)+40 + 2*SizeOf(TRGBQuad) + I*(1920 div 8));
      Move(P^, Buffer[695-I], 1920 div 8);
      end;
    GlobalUnlock(DIB);
    GlobalFree(DIB);
    DeleteObject(DIB);

    SetBitmapBits(B, SizeOf(Buffer), @Buffer);
    
    TB:=TBitmap.Create;
    TB.Handle:=B;
    TB.SaveToFile('2.bmp');
    TB.Free;    // DeleteObject(B) not needed
    L_FreeBitmap(L);
  until False;
end.